-- ZB_DM_XXZBDBF_HB_NEW ZB_DM_新续转保单保费合并_NEW


-- step1：
-- 团队汇总
CREATE TEMPORARY VIEW VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI AS
SELECT
      a1.`uwConclueDate`                                                as `uwConclueDate`
     ,a1.`LEVEL1COMCODE`                                                as `LEVEL1COMCODE`
     ,a1.`LEVEL2COMCODE`                                                as `LEVEL2COMCODE`
     ,a1.`LEVEL3COMCODE`                                                as `LEVEL3COMCODE`
     ,a1.`LEVEL4COMCODE`                                                as `LEVEL4COMCODE`
     ,a1.`startTime`                                                    as `startTime`
     ,a1.`xxzflag`                                                      as `xxzflag`
     ,a1.`cost` + if(t1.cost is null ,0,cast(t1.cost as decimal(18,2))) as `cost`
from (
         SELECT
              s1.`uwConclueDate`                     as `uwConclueDate`
            , s1.`xxzflag`                           as `xxzflag`
            , s1.`LEVEL1COMCODE`                     as `LEVEL1COMCODE`
            , s1.`LEVEL2COMCODE`                     as `LEVEL2COMCODE`
            , s1.`LEVEL3COMCODE`                     as `LEVEL3COMCODE`
            , s1.`LEVEL4COMCODE`                     as `LEVEL4COMCODE`
            , s1.`startTime`                         as `startTime`
            , sum(cast(s1.`cost` as DECIMAL(18, 2))) as `cost`
            , max(s1.proctime)                       as proctime
         from ZB_ODS.ZB_ODS_KAFKA.CBDATA s1
         where
             s1.`COMNAME` is not null
           and s1.`uwConclueDate` = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
           and LongTimeToStringUDF(s1.log_time,'yyyyMMdd HH') = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd HH')
         group by
             s1.`uwConclueDate`
             , s1.`xxzflag`
             , s1.`LEVEL1COMCODE`
             , s1.`LEVEL2COMCODE`
             , s1.`LEVEL3COMCODE`
             , s1.`LEVEL4COMCODE`
             , s1.`startTime`
     ) a1
 left join ZB_DM.ZB_DM_MYSQL.ZB_DM_TEAM_XXZFLAG for system_time as of a1.proctime as t1
        on a1.`uwConclueDate` = t1.`uwConclueDate`
       and a1.`LEVEL4COMCODE` = t1.`LEVEL4COMCODE`
       and a1.`startTime`     = t1.`startTime`
       and a1.`xxzflag`       = t1.`xxzflag`
;

-- 总公司
insert into ZB_DM.ZB_DM_REDIS.SET_DECIMAL
select
    CONCAT(
            'xxzbf/'
        ,s1.`uwConclueDate`
        )                                      as `key`
     ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
group by
    s1.`uwConclueDate`
;

-- 分公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'provxxzbf/'
        ,s1.`uwConclueDate`
        )                                      as `key`
     ,s1.`LEVEL1COMCODE`                    as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
group by
    s1.`uwConclueDate`
       ,s1.`LEVEL1COMCODE`
;

-- ZB_DM_XXZBDBF ZB_DM_新续转保单保费
-- key:xxzbf/日期
-- 1、日期:核保日期或者核批完成日期(yyyyMMdd)
-- 2、新续转保得保单

-- 中支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'cityxxzbf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL2COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
group by
    s1.`uwConclueDate`
       ,s1.`LEVEL2COMCODE`
;

-- 县支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'countryxxzbf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL3COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
group by
    s1.`uwConclueDate`
       ,s1.`LEVEL3COMCODE`
;

-- 团队
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'teamxxzbf/'
        ,s1.`uwConclueDate`
        )                                   as `key`
     ,s1.`LEVEL4COMCODE`                    as `hkey`
     ,cast(s1.`cost` as DECIMAL(18,2))      as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
;

-- ZB_DM_XXZBDBFNDQQB ZB_DM_新续转保单保费年底前起保
-- key:xxzyearbf/日期
-- 1、日期:核保日期或者核批完成日期(yyyyMMdd)
-- 2、新续转保得保单
-- 3、起保时间小于等于今年

-- 总公司
insert into ZB_DM.ZB_DM_REDIS.SET_DECIMAL
select
    CONCAT(
            'xxzyearbf/'
        ,s1.`uwConclueDate`
        )                                      as `key`
     ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,4) <= DATE_FORMAT(LOCALTIMESTAMP,'yyyy')
group by
    s1.`uwConclueDate`
;

-- 分公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'provxxzyearbf/'
        ,s1.`uwConclueDate`
        )                                      as `key`
     ,s1.`LEVEL1COMCODE`                    as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,4) <= DATE_FORMAT(LOCALTIMESTAMP,'yyyy')
group by
    s1.`uwConclueDate`
        ,s1.`LEVEL1COMCODE`
;


-- 中支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'cityxxzyearbf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL2COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,4) <= DATE_FORMAT(LOCALTIMESTAMP,'yyyy')
group by
    s1.`uwConclueDate`
        ,s1.`LEVEL2COMCODE`
;

-- 县支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'countryxxzyearbf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL3COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,4) <= DATE_FORMAT(LOCALTIMESTAMP,'yyyy')
group by
    s1.`uwConclueDate`
        ,s1.`LEVEL3COMCODE`
;

-- 团队
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'teamxxzyearbf/'
        ,s1.`uwConclueDate`
        )                                   as `key`
     ,s1.`LEVEL4COMCODE`                    as `hkey`
     ,cast(s1.`cost` as DECIMAL(18,2))      as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,4) <= DATE_FORMAT(LOCALTIMESTAMP,'yyyy')
;


-- ZB_DM_XXZBDBFJDMQQB ZB_DM_新续转保单保费季度末前起保
-- key:xxzquarterbf/日期
-- 1、日期:核保日期或者核批完成日期(yyyyMMdd)
-- 2、新续转保得保单
-- 2、起保时间的季度小于等于当前季度
-- 总公司
insert into ZB_DM.ZB_DM_REDIS.SET_DECIMAL
select
    CONCAT(
        'xxzquarterbf/'
        ,s1.`uwConclueDate`
    )                                      as `key`
    ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where  s1.`xxzflag` = '1'
-- 起保时间的季度小于等于当前季度
and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
         END
group by
    s1.`uwConclueDate`
;

-- 分公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
        'provxxzquarterbf/'
        ,s1.`uwConclueDate`
    )                                      as `key`
    ,s1.`LEVEL1COMCODE`                    as `hkey`
    ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where  s1.`xxzflag` = '1'
-- 起保时间的季度小于等于当前季度
and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
         END
group by
     s1.`uwConclueDate`
    ,s1.`LEVEL1COMCODE`
;


-- 中支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'cityxxzquarterbf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL2COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where  s1.`xxzflag` = '1'
-- 起保时间的季度小于等于当前季度
and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
         END
group by
    s1.`uwConclueDate`
   ,s1.`LEVEL2COMCODE`
;

-- 县支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'countryxxzquarterbf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL3COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where  s1.`xxzflag` = '1'
-- 起保时间的季度小于等于当前季度
and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
         END
group by
    s1.`uwConclueDate`
    ,s1.`LEVEL3COMCODE`
;

-- 团队
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'teamxxzquarterbf/'
        ,s1.`uwConclueDate`
        )                                   as `key`
     ,s1.`LEVEL4COMCODE`                    as `hkey`
     ,cast(s1.`cost` as DECIMAL(18,2))      as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where  s1.`xxzflag` = '1'
-- 起保时间的季度小于等于当前季度
and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
         WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
         END
;



-- ZB_DM_XXZBDBFYDQQBYDQQB ZB_DM_新续转保单保费月底前起保
-- key:xxzmonthbf/日期
-- 1、日期:核保日期或者核批完成日期(yyyyMMdd)
-- 2、新续转保得保单
-- 3、起保时间小于等于当月

-- 总公司
insert into ZB_DM.ZB_DM_REDIS.SET_DECIMAL
select
    CONCAT(
            'xxzmonthbf/'
        ,s1.`uwConclueDate`
        )                                      as `key`
     ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,6) <= DATE_FORMAT(LOCALTIMESTAMP,'yyyyMM')
group by
    s1.`uwConclueDate`
;

-- 分公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'provxxzmonthbf/'
        ,s1.`uwConclueDate`
        )                                      as `key`
     ,s1.`LEVEL1COMCODE`                    as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,6) <= DATE_FORMAT(LOCALTIMESTAMP,'yyyyMM')
group by
    s1.`uwConclueDate`
        ,s1.`LEVEL1COMCODE`
;


-- 中支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'cityxxzmonthbf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL2COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,6) <= DATE_FORMAT(LOCALTIMESTAMP,'yyyyMM')
group by
    s1.`uwConclueDate`
        ,s1.`LEVEL2COMCODE`
;

-- 县支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'countryxxzmonthbf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL3COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,6) <= DATE_FORMAT(LOCALTIMESTAMP,'yyyyMM')
group by
    s1.`uwConclueDate`
        ,s1.`LEVEL3COMCODE`
;

-- 团队
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'teamxxzmonthbf/'
        ,s1.`uwConclueDate`
        )                                   as `key`
     ,s1.`LEVEL4COMCODE`                    as `hkey`
     ,cast(s1.`cost` as DECIMAL(18,2))      as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,6) <= DATE_FORMAT(LOCALTIMESTAMP,'yyyyMM')
;



-- ZB_DM_XXZBDBFDRQDDRQB ZB_DM_新续转保单保费当日签单当日起保
-- key:xxzdaybf/日期
-- 1、日期:核保日期或者核批完成日期(yyyyMMdd)
-- 2、新续转保得保单
-- 3、起保时间等于今天

-- 总公司
insert into ZB_DM.ZB_DM_REDIS.SET_DECIMAL
select
    CONCAT(
            'xxzdaybf/'
        ,s1.`uwConclueDate`
        )                                      as `key`
     ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,8) = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
group by
    s1.`uwConclueDate`
;

-- 分公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'provxxzdaybf/'
        ,s1.`uwConclueDate`
        )                                      as `key`
     ,s1.`LEVEL1COMCODE`                    as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2))) as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,8) = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
group by
    s1.`uwConclueDate`
        ,s1.`LEVEL1COMCODE`
;


-- 中支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'cityxxzdaybf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL2COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,8) = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
group by
    s1.`uwConclueDate`
        ,s1.`LEVEL2COMCODE`
;

-- 县支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'countryxxzdaybf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL3COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,8) = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
group by
    s1.`uwConclueDate`
        ,s1.`LEVEL3COMCODE`
;

-- 团队
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'teamxxzdaybf/'
        ,s1.`uwConclueDate`
        )                                   as `key`
     ,s1.`LEVEL4COMCODE`                    as `hkey`
     ,cast(s1.`cost` as DECIMAL(18,2))      as `val`
from VIEW_ZB_DM_XXZBDBF_HB_NEW_TUANDUI s1
where s1.`xxzflag` = '1'
  and left(s1.`startTime`,8) = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
;